import pygame, random
import var

def initialize():
  global asize, amap, amap2, killmap, newcheck, jace, xa, ya
  asize = xa, ya = var.xm / var.cell, var.ym / var.cell
  amap = pygame.Surface(asize)
  amap2 = pygame.Surface(asize)
  amap2.fill(var.black)
  killmap = pygame.Surface(asize)
  killmap.set_colorkey(var.white)
  killmap.fill(var.white)
  newcheck = set()  # set of all cells that need to be checked
  r = var.carad
  for x in xrange(-r, r):
    for y in xrange(-r, r):
      if x*x + y*y < r*r and random.random() < 0.5:
        amap2.set_at((x % xa, y % ya), var.grey)
  for x in xrange(-r-1, r+1):
    for y in xrange(-r-1, r+1):
      newcheck.add((x % xa, y % ya))
  jace = set()
  for x in (-1,0,1):
    for y in (-1,0,1):
      if x != 0 or y != 0:
        jace.add((x,y))
  startgen()

def update():
  global lastgen, index0, amap, jace, newcheck, amap2, xa, ya
  now = pygame.time.get_ticks()
  dtime = float(now - lastgen) / var.gen
  index1 = min(int(dtime * len(tocheck) * 1.1), ncheck)
  for j in xrange(index0, index1):
    x, y = tocheck[j]
    neigh = set()
    for dx, dy in jace:
      neigh.add(((x+dx) % xa, (y+dy) % ya))
    score = 0
    for n in neigh:
      if amap.get_at(n) == var.grey:
        score += 1
        if score >= 5:
          break
    wasset = amap.get_at((x,y)) == var.grey
    isset = score >=  5 or score == 3
    if isset != wasset:
      amap2.set_at((x,y), (var.black, var.grey)[isset])
      newcheck |= neigh
  index0 = index1
  if dtime >= 1: startgen()

def startgen():
  global tocheck, newcheck, ncheck, amap, amap2, killmap, layer, lastgen, index0
  tocheck = list(newcheck)
  ncheck = len(tocheck)
  newcheck = set()
  amap.blit(amap2, (0,0))
  amap.set_colorkey(var.black)
  amap.blit(killmap, (0,0))
  amap2 = amap.copy()
  layer = pygame.transform.scale(amap, var.msize)
  lastgen = pygame.time.get_ticks()
  index0 = 0


