import sys, pygame, random, math
import var, terrain, structure, automaton, text, intro

def main():

  pygame.init()

  xf, yf = 0, 0  # viewport offset
  xg, yg = 0, 0  # viewport destination

  view = pygame.Surface(var.vsize)
  screen = pygame.display.set_mode((var.xv, var.yv))
  rightclick = False
  leftclick = False
  isj = False
  cursormode = ""

  terr = terrain.tthread(var.terrain1, var.terrain2, var.msize, 60, 1)
  terr.start()
  text.initialize()
  playing = True
  automaton.initialize()
  structure.initialize()

  topbar = pygame.Surface((var.xv, 54)).convert_alpha()
  topbar.fill(var.thingrey)
  for j in xrange(1, 7):
    pygame.draw.line(topbar, var.white, (54*j, 0), (54*j, 54))
  j = 54/2
  cicon = { "factory": structure.fimg, "electric": structure.eimg, "mine": structure.mimg,
    "shield": structure.simg, "launch": structure.limg, "warhead": structure.wimg,
    "remove": structure.rimg }
  for img in structure.imgs:
    topbar.blit(img, (j-img.get_width()/2, 54/2-img.get_height()/2))
    j += 54

  if intro.go1(screen):
    tmap0 = terr.getterrain().convert_alpha()
    tmap = tmap0.copy()

    a0 = math.floor((xf-var.xv2)/var.xm)
    a1 = math.floor((xf+var.xv2)/var.xm)
    b0 = math.floor((yf-var.yv2)/var.ym)
    b1 = math.floor((yf+var.yv2)/var.ym)
    ps = set()
    for a in xrange(int(a0), int(a1)+1):
      for b in xrange(int(b0), int(b1)+1):
        ps.add((var.xv2 - xf + a * var.xm, var.yv2 - yf + b * var.ym))
    for p in ps:
      view.blit(tmap, p)
    view2 = view.copy()
    for p in ps:
      view2.blit(automaton.layer, p)
    intro.go2(screen, view, view2)
    intro.showtitle(screen)
  else:
    intro.showtitle(screen)
    tbox = text.font.render("Loading....", True, var.white)
    screen.blit(tbox, (100, 400))  
    pygame.display.flip()
    tmap0 = terr.getterrain().convert_alpha()
    tmap = tmap0.copy()

  text.addnotice("All personnel evacuate to City Hall")

  while playing and automaton.ncheck > 0:
    automaton.update()
    pygame.event.get()
    keys = pygame.key.get_pressed()
    clicks = pygame.mouse.get_pressed()
  
    if keys[pygame.K_q] or keys[pygame.K_ESCAPE]:
      playing = False

    xc0, yc0 = pygame.mouse.get_pos()
    xc = (xc0 + xf - var.xv2 + var.xm2) % var.xm - var.xm2
    yc = (yc0 + yf - var.yv2 + var.ym2) % var.ym - var.ym2

    leftclicking = clicks[0] and not leftclick
    leftclick = clicks[0]
  
    if leftclicking:
      if yc0 < 54:
        if xc0 < 54: cursormode = "factory"
        elif xc0 < 2*54: cursormode = "electric"
        elif xc0 < 3*54: cursormode = "mine"
        elif xc0 < 4*54: cursormode = "shield"
        elif xc0 < 5*54: cursormode = "launch"
        elif xc0 < 6*54: cursormode = "warhead"
        elif xc0 < 7*54: cursormode = "remove"
        else: cursormode = ""
      elif cursormode == "":
        pass
      elif cursormode == "remove":
        structure.remove(xc, yc, 30)
      elif var.money < var.cost[cursormode]:
        text.addnotice("You can't afford that!")
      elif structure.toonear(xc, yc):
        text.addnotice("Can't build that close to another structure!")
      elif cursormode == "electric":
        structure.slist.append(structure.Electric((xc, yc)))
        var.money -= var.cost['electric']
        cursormode = ""
      elif cursormode == "factory":
        structure.slist.append(structure.Factory((xc, yc)))
        var.money -= var.cost['factory']
        cursormode = ""
      else:
        if structure.mmap.get_at((xc%var.xm, yc%var.ym)) != var.black:
          text.addnotice("Can't build that close to another land-using structure!")
        elif cursormode == "shield":
          structure.slist.append(structure.Shield((xc, yc)))
          var.money -= var.cost['shield']
          cursormode = ""
        elif cursormode == "mine":
          structure.slist.append(structure.Mine((xc, yc)))
          var.money -= var.cost['mine']
          cursormode = ""
        elif cursormode == "launch":
          structure.slist.append(structure.Launch((xc, yc)))
          var.money -= var.cost['launch']
          cursormode = ""
        elif cursormode == "warhead":
          structure.slist.append(structure.Warhead((xc, yc)))
          var.money -= var.cost['warhead']
          cursormode = ""
  
    if keys[pygame.K_s]:
      cursormode = "shield"
    if keys[pygame.K_e]:
      cursormode = "electric"
    if keys[pygame.K_m]:
      cursormode = "mine"
    if keys[pygame.K_f]:
      cursormode = "factory"
    if keys[pygame.K_l]:
      cursormode = "launch"
    if keys[pygame.K_w]:
      cursormode = "warhead"
    if keys[pygame.K_r]:
      cursormode = "remove"
  
    if keys[pygame.K_u]:
      xg, yg = 0, 0
    if keys[pygame.K_c]:
      xg, yg = var.xm2, var.ym2
      
    wasj = isj
    isj = keys[pygame.K_j]
    if wasj and not isj:
      xg, yg = xf + xc0 - var.xv2, yf + yc0 - var.yv2

    if clicks[2]:
      xr, yr = pygame.mouse.get_pos()
      if rightclick:
        if xr != xr0 or yr != yr0:
          torightscoot = False
          xf -= xr - xr0
          yf -= yr - yr0
          xg, yg = xf, yf
      else:
        torightscoot = rightclick = True
      xr0, yr0 = xr, yr
    else:
      if rightclick:
        rightclick = False
        if torightscoot:
          xg, yg = xf + xr0 - var.xv2, yf + yr0 - var.yv2
  
    structure.infect(automaton.layer)
    structure.disinfect(automaton.killmap)
    structure.update()
  
    dx, dy = xg - xf, yg - yf
    if dx or dy:
      if abs(dx) > var.xm2:
        dx = (dx + var.xm2) % var.xm - var.xm2
        xf = xg - dx
      if abs(dy) > var.ym2:
        dy = (dy + var.ym2) % var.ym - var.ym2
        yf = yg - dy
  
      zf = 0.5
      if dx > 200: xf += 100
      elif dx < -200: xf -= 100
      elif abs(dx) > 1/zf: xf = int(xf*(1-zf) + xg*zf)
      else: xf = xg
      if dy > 200: yf += 100
      elif dy < -200: yf -= 100
      elif abs(dy) > 1/zf: yf = int(yf*(1-zf) + yg*zf)
      else: yf = yg
  
    a0 = math.floor((xf-var.xv2)/var.xm)
    a1 = math.floor((xf+var.xv2)/var.xm)
    b0 = math.floor((yf-var.yv2)/var.ym)
    b1 = math.floor((yf+var.yv2)/var.ym)
    ps = set()
    for a in xrange(int(a0), int(a1)+1):
      for b in xrange(int(b0), int(b1)+1):
        ps.add((var.xv2 - xf + a * var.xm, var.yv2 - yf + b * var.ym))
    for p in ps:
      view.blit(tmap, p)
      view.blit(structure.fmap, p)
      view.blit(structure.emap, p)
      view.blit(structure.mmap, p)
  
    for s in structure.slist:
      s.place(var.vsize, (xf, yf), var.msize)
    for s in structure.slist:
      s.draw0(view)
    for s in structure.slist:
      s.draw1(view)
  
    for p in ps:
      view.blit(automaton.layer, p)
  
    screen.blit(view, (0, 0))
  
    screen.blit(topbar, (0, 0))
    mtext = text.font.render("Resources: " + str(int(var.money)), True, var.white)  
    screen.blit(mtext, (500, 0))
  
    text.update(screen)
    if yc0 < 54:
      n = int(xc0 / 54)
      if n < 6:
        s = var.stype[n]
        mtext = text.font.render(var.bname[s], True, var.black)  
        screen.blit(mtext, (0, 54))
        mtext = text.font.render("Cost: " + str(var.cost[s]), True, var.black)  
        screen.blit(mtext, (0, 74))
        mtext = text.font.render("Build time: " + str(var.btime[s]) + " seconds", True, var.black)  
        screen.blit(mtext, (0, 94))
      elif n == 6:
        mtext = text.font.render("Remove buildings (no refunds)", True, var.black)  
        screen.blit(mtext, (0, 54))
            
    if yc0 >= 54 and cursormode != "":
      icon = cicon[cursormode]
      screen.blit(icon, (xc0-icon.get_width()/2,yc0-icon.get_height()/2))
  
    pygame.display.flip()
    if var.launching:
      playing = False
  
  if var.launching:
    intro.ending(screen)
    

