import pygame, math, random, threading
import var, text

class tthread (threading.Thread):
  def __init__(self, color1, color2, size, featuresize, saturation):
    threading.Thread.__init__(self)
    self.color1 = color1
    self.color2 = color2
    self.size = size
    self.fsize = featuresize
    self.nhill = int(size[0] * size[1] / self.fsize / self.fsize * saturation)
    self.map = pygame.Surface(size)
    self.done = False
  def getterrain(self):
    while not self.done: pass
    return self.map
  def run(self):
    hill = pygame.Surface((6*self.fsize, 6*self.fsize)).convert_alpha()
    hill.fill(var.black)
    self.map.fill(self.color1)
    for h in xrange(1, 30):
      color = (self.color2[0], self.color2[1], self.color2[2], h)
      r = int(self.fsize * math.sqrt(-2. * math.log(h/30.)))
      pygame.draw.circle(hill, color, (3*self.fsize, 3*self.fsize), r)
    sx, sy = self.size
    for k in xrange(0, self.nhill):
      s = random.randint(2*self.fsize, 6*self.fsize)
      px, py = random.randint(0, sx), random.randint(0, sy)
      for a in xrange(0, 1+int((px + s)/sx)):
        for b in xrange(0, 1+int((py + s)/sy)):
          self.map.blit(pygame.transform.scale(hill, (s,s)), (px-a*sx, py-b*sy))

    university = pygame.image.load("university.png").convert_alpha()
    xp, yp = -university.get_width()/2, -university.get_height()/2
    uname = text.smallfont.render("Pastel University", True, var.black)
    for a in (0, 1):
      for b in (0, 1):
        self.map.blit(university, (xp + a * var.xm, yp + b * var.ym))
        self.map.blit(uname, (xp + a * var.xm, yp - 24 + b * var.ym))
    cityhall = pygame.image.load("city-hall.png").convert_alpha()
    xp, yp = var.xm2 - cityhall.get_width()/2, var.ym2 - cityhall.get_height()/2
    cname = text.smallfont.render("City Hall", True, var.black)
    self.map.blit(cityhall, (xp, yp))
    self.map.blit(cname, (xp + 24, yp - 24))

    self.done = True

