import pygame
import var

def initialize():
  global font, smallfont
  font = pygame.font.Font("Vera.ttf", 18)
  smallfont = pygame.font.Font("Vera.ttf", 12)

def addmessage(words, color, xc, yc):
  global font, tbox, tabox, xt, yt, tbegin, tlen
  tbox = font.render(words, False, color)
  tabox = font.render(words, True, color)
  xt = xc - tbox.get_width()/2
  yt = yc - tbox.get_height()/2
  tlen = tbox.get_width() * var.tshow
  tbegin = pygame.time.get_ticks()
  
def update(surf):
  global tbox, tabox, xt, yt, tbegin, tlen
  now = pygame.time.get_ticks()
  dt = now - tbegin
  if dt < var.tfade:
    tbox.set_alpha(int(255. * dt / var.tfade))
    surf.blit(tbox, (xt, yt))  
  elif dt < var.tfade + tlen:
    surf.blit(tabox, (xt, yt))
  elif dt < 2 * var.tfade + tlen:
    dt = 2 * var.tfade + tlen - dt
    tbox.set_alpha(int(255. * dt / var.tfade))
    surf.blit(tbox, (xt, yt))
  else:
    return False
  return True
  
def addnotice(words):
  addmessage(words, var.black, var.xv2, var.yv - 10)

